//Camera class interface

#ifndef _CAMERA_H_
#define _CAMERA_H_

#include "main.h"

//The camera class
class Camera
{
public:
	//default camre constructor
	Camera(){}

	//Camera class data member access functions
	inline Vector3 Position() {return m_vPosition;}
	inline Vector3 View()		{return m_vView;}
	inline Vector3 UpVector() {return m_vUpVector;}
	inline Vector3 Strafe()	{return m_vStrafe;}
	
	//Get vector info
	inline GLfloat GetPosX(){return m_vPosition.x;}
	inline GLfloat GetPosY(){return m_vPosition.y;}
	inline GLfloat GetPosZ(){return m_vPosition.z;}
	inline GLfloat GetViewX(){return m_vView.x;}
	inline GLfloat GetViewY(){return m_vView.y;}
	inline GLfloat GetViewZ(){return m_vView.z;}

	//Camera controlm functions
	void PositionCamera(GLfloat positionX, GLfloat positionY, GLfloat positionZ,
			 		    GLfloat viewX,     GLfloat viewY,     GLfloat viewZ,
						GLfloat upVectorX, GLfloat upVectorY, GLfloat upVectorZ);

	//Camera rotation
	void RotateView(GLfloat angle, GLfloat x, GLfloat y, GLfloat z);

	//Mouse control
	void SetViewByMouse(); 

	//Camera strafing 
	void StrafeCamera(GLfloat speed);

	//Forward and backward camera movement
	void MoveCamera(GLfloat speed);

	//Check user keyboard for input 
	void CheckForMovement();

	//Update the camera view and associated data members
	void Update();

	//Function call to set up gluLookAt() with the user generated camera coordinates
	void Look();

private:

	//camera position
	Vector3 m_vPosition;					

	//camera view
	Vector3 m_vView;						

	//camera up vector
	Vector3 m_vUpVector;		
	
	//camera strafe vector
	Vector3 m_vStrafe;	
};

#endif