//Main program interface
//All include files must be listed here

#ifndef _MAIN_H_
#define _MAIN_H_

//system includes
#include <windows.h>
#include <stdio.h>
#include <mmsystem.h>
#include <math.h>
#include <fstream>

//OpenGL includes
#include <GL/gl.h>
#include <GL/glu.h>
#include "glext.h"

//local includes 
#include "vector3.h"
#include "terrain.h"
#include "camera.h"
#include "scene.h"
#include "Model.h"
#include "MilkshapeModel.h"
#include "tex.h"

//OpenGL extension defines
#define GL_CLAMP_TO_EDGE	0x812F	

//global defines
#define COLOUR_DEPTH 32	//Colour depth
#define S_WIDTH	 1024		//client area resolution
#define S_HEIGHT 768
#define C_SPEED 0.8f //camera movement speed

//global window variables
extern HWND        ghwnd;
extern HDC			ghdc;
extern HGLRC		ghrc;			
extern HINSTANCE	ghInstance;
extern RECT		gRect;
extern RECT		screenRect;

/////////////////////////////////
//Global game object variables
/////////////////////////////////
extern GLuint	Textures[10];
extern Model * SceneModels [40];
extern Camera g_Camera;
extern DEFAULT_TERRAIN test_terrain;

//WinAPI/OpenGL windowing function prototypes
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);
HWND CreateGLWindow(LPCSTR strWindowName, int width, int height, DWORD dwStyle, bool bFullScreen, HINSTANCE hInstance);
bool SetPixelFormat(HDC hdc);
void ResizeGLWindow(int width, int height);
void InitializeOpenGL(int width, int height);
void Cleanup();

#endif