//3D vector class interface

#ifndef _VECTOR3_H_
#define _VECTOR3_H_

#include "main.h"

//3D vector class
class Vector3
{
public:

	//vector class default constructor
	Vector3(){}

	//vector class constructor
	Vector3(GLfloat X, GLfloat Y, GLfloat Z) 
	{ 
		x = X; y = Y; z = Z;
	}

	//Overloaded operators used for vector arithmetic
	Vector3 operator+(Vector3 vVector)
	{
		return Vector3(vVector.x + x, vVector.y + y, vVector.z + z);
	}

	Vector3 operator-(Vector3 vVector)
	{
		return Vector3(x - vVector.x, y - vVector.y, z - vVector.z);
	}
	
	Vector3 operator*(GLfloat num)
	{
		return Vector3(x * num, y * num, z * num);
	}

	Vector3 operator/(GLfloat num)
	{
		return Vector3(x / num, y / num, z / num);
	}

	//3D vector operations
	Vector3 Cross(Vector3 vVector1, Vector3 vVector2);
	Vector3 Normalize(Vector3 vVector);
	GLfloat Magnitude(Vector3 vNormal);

	//publicly accessed data members
	GLfloat x, y, z;
};


#endif